# -*- encoding : utf-8 -*-

class Admin::ArticlesController < ApplicationController

	before_action :auth_admin
	
	layout "admin"
	


	before_action :find_articles

	def index 

	end


	def cible
		
		render :layout => false
		
	end
	
	
	def new
	
		@article = Article.new(:published_at => Time.now)
    
    
    LangSite.all.each do |ls|
      @article.lang_articles << LangArticle.new(:lang_site_id => ls.id)
    end

	end


	def edit
	
    params[:lang] = params[:lang] || "fr"
    
    @lang = LangSite.find_by_slug(params[:lang])
  
		@article = Article.find(params[:id])
    
		
	end
  
	def edit_menu_items
	
    params[:lang] = params[:lang] || "fr"
    
    @lang = LangSite.find_by_slug(params[:lang])
  
		@article = Article.find(params[:id])
    
		
	end


	def create
		
		@article = Article.new(article_params)

		
		if @article.save
			flash[:notice] = "L'article à été ajouté avec succès."
			self.find_articles
		
		else
			render :action => "new" 

		end

	end


	def update
	
		@article = Article.find(params[:id])
	
  
    if params[:article]
  		if @article.update_attributes(article_params)
  			flash[:notice] = "L'article à été modifié avec succès."
  		else
  			render :action => "edit"
  		end
      
      
    elsif params[:tag_id]
      @article.tag_by_tag_ids(params[:tag_id])
    end
    
  
  
		
	end


	def destroy
	
		@article = Article.find(params[:id])
		@article.destroy

	end
	
	protected
	
	def find_articles
		date_regex = /^(0[1-9]|[12][0-9]|3[01])[\/](0[1-9]|1[012])[\/](19|20)\d\d$/i 
		if params[:start] and params[:start] =~ date_regex
			start = Date.parse(params[:start]).beginning_of_day 
			params[:start]= start.strftime('%d/%m/%Y')
		else
			params[:start] = ""
		end
		if params[:stop] and params[:stop] =~ date_regex
			stop = Date.parse(params[:stop]).end_of_day 
			params[:stop]= stop.strftime('%d/%m/%Y')
		 else
		 	params[:stop] = ""
		end
		
		@articles = Article.order('published_at DESC')
		@articles = @articles.after(start) if start
		@articles = @articles.before(stop) if stop
		per_page = (params[:per_page] and params[:per_page] != "") ? params[:per_page] : 5000
		page = (params[:page] and params[:page] != "") ? params[:page] : 1 
		@articles = @articles.page(page).per(per_page)

		#@articles = Event.order('start_at, stop_at').after(start).before(stop)
	end
	
  private
    def article_params
      params.require(:article).permit!
      
  
      
      
    end

  
end
